#!/bin/sh

. ~/etc/setenv.sh

sid="$1"

if [ -z "$sid" ] ; then
	exit 255
fi

SessionDir="$TMP/mediasession/mediasession_$sid"

if [ -d "${SessionDir}" ]; then
	if [ -f "${SessionDir}/burning.in.progress" ]; then
		touch "${SessionDir}/autoclean.on.finish"
	else 
		if [ ! -f "${SessionDir}/cdimage.done" ]; then
			pid=`cat "${SessionDir}/pid"`
			[ -n "$pid" ] && kill $pid
		fi
		
		echo Cleaning up CD job $sid
		rm -rf "${SessionDir}"
	fi
fi

