
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="imagemed.util.LocalizedMessage"%>
<%@page import="imagemed.layout.macro.Macro"%>
<%@page import="imagemed.layout.macro.button.LogButtonMacro"%>
<%@page import="java.util.Properties"%>
<%@page import="imagemed.layout.LayoutRoot"%>
<%@page import="imagemed.util.Helper"%>
<%@page import="imagemed.util.FilterNames"%>
<%@page import="imagemed.layout.cache.LayoutCache"%>
<%@page import="java.io.File"%>
<%@page import="imagemed.layout.LayoutPart"%>
<%@page import="java.util.StringTokenizer"%><%---------------------------
		Validates the user actions (HTTP outbound interface) in popup
     -------------------------
--%>
<%@
  page errorPage ="../main/exceptionHandler.jsp"
%>
<%

	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );

  boolean actionFound = false;
	String actions = request.getParameter("actions");
	if ( actions != null && !"null".equals( actions ) ) {
		Properties props = new Properties();
		props.setProperty( Macro.TYPE, Macro.BUTTON );
		props.setProperty( Macro.SUBTYPE, Macro.LOG );
		
		StringTokenizer st = new StringTokenizer( actions, "\n" );
		while ( st.hasMoreTokens() ) {
			String line = st.nextToken().trim();
			if ( !line.startsWith( "#" ) && !"".equals( line ) ) {
				String action = line;
				actionFound = true;
				out.println( "Checking User Action: <B>" + action + "</B> in xml files<BR>" );

				boolean found = false;
				
				props.setProperty( LogButtonMacro.ACTION, action );

				for( int j = 0; j < LayoutPart.LAYOUTTYPES.size(); j++ ) {
					String layoutType = LayoutPart.LAYOUTTYPES.get(j);
					String layoutDisplay = LocalizedMessage.getSimpleMessage( LayoutPart.LAYOUTTYPENAMES.get(j) );
					
					//combined layout types (A.B) refer to the basic type, so they will not be handled twice
					if( !LayoutPart.isLayoutTypeCombined( layoutType ) ) {
					
						String xmlFolder = LayoutCache.getXmlDir( layoutType );
		
						String[] xmlNames = Helper.getDirectoryContentAsStringArray(xmlFolder, "*.xml");
						
						try {
							LayoutRoot root = LayoutCache.getLayout(sess, layoutType, null, false );
							if( root.getDescendantByPropertyValues( props ) != null ) {
								found = true;
								out.println( "&nbsp;&nbsp;Found in layout <B>" + layoutDisplay + "</B> in <B>Built in default xml</B><BR>" );
							}
						}
						catch( Throwable th ) {
							Helper.ERRORLOG( "Exception in layout:" + layoutType + "built in default:" + Helper.throwable2String( th ) );								
						}
						
						
						if( xmlNames != null && xmlNames.length > 0 ) {
							xmlNames = Helper.sortCaseInSensitive( xmlNames );
							for( int i = 0; i < xmlNames.length; i++ ) {
								try {
									LayoutRoot root = LayoutCache.getLayout( sess, layoutType, xmlNames[ i ], false );
									if( root.getDescendantByPropertyValues( props ) != null ) {
										found = true;
										out.println( "&nbsp;&nbsp;Found in layout <B>" + layoutDisplay + "</B> in <B>" + xmlNames[ i ] + "</B><BR>" );
									}
								}
								catch( Throwable th ) {
									Helper.ERRORLOG( "Exception in layout:" + layoutType + " name:" + xmlNames[ i ] + " : " + Helper.throwable2String( th ) );								
								}
							}
						}
					}
				}
				if( !found ) {
					out.println( "&nbsp;&nbsp;Not found<BR>" );
				}
				out.println( "<BR>" );
			}
		}
		if( !actionFound ) {
			out.println( "There is no User Action to check<BR>" );
		}
	}

%>  
