<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *    Gets a document file extracted from a DICOM Encapsulated PDF (or other document) object.
 *
 * Params:
 *   cStudy        - Study Instance UID
 *   cFile         - DICOM Encapsulated Document Object File
 *   cTargetDevice - indicates to redirect to this particular device instead of usual redirection
 *
 *
 * SEEMS NOT USED - we may want to check and remove this file
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
-- %><%@
	page import="imagemed.dotcom.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.util.*,
			java.util.*, java.io.*, java.sql.*"

%><%!
	static final int SIZE = 65536;//525312;

%><%
	IMSession is = new IMSession( request, response, out ); 
	Syslog logger = new Syslog( "getDocument", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );
	
	is.bCheckHttpsAndRedirect = false;
	if ( !ProxyToolbox.init( is, null, logger ) ) {
		// There was no session checking here - we may want to consider to check session here 
	}
	
	String study = request.getParameter( "cStudy" );
	String file = request.getParameter( "cFile" );
	String targetDevice = request.getParameter("cTargetDevice");

	if ( study == null ) {
		ResultSet rs = IMEnv.getDB().prepareStatement( "select STYIUID from " + IMEnvBase.getEnv( "OBJECTTBL" ) + " where FNAME='" + Helper.sqlEncode( file ) + "'" ).executeQuery();
		if ( rs.next() ) {
			study = rs.getString("STYIUID");
		}
		rs.close();
	}

	if ( study == null || file == null ) {
		logger.syslog( Syslog.LOG_DEBUG, "Study or File is null" );
		return;
	}

	//CWL, showimages calling
	if( DotcomConfig.selfDevice().isDbOnly() && targetDevice != null && !"".equals( targetDevice ) ) {
		String redirURL = RedirectToolbox.getURL( DotcomConfig.getConfig().getServerNameTowards( targetDevice ), is.regIP, null );
		if( redirURL != null ) {
			redirURL += "/cases/getDocument.jsp?" + request.getQueryString();
			response.sendRedirect(redirURL);
			return;
		}
	}
	
	String redirHost = RedirectToolbox.getClosestRedirectHostForStudy( is, study );
	if ( redirHost != null ) {
		String redirURL = RedirectToolbox.getClosestRedirectForStudy( is, study ) + "/cases/getDocument.jsp?" + request.getQueryString();
		response.sendRedirect( redirURL );
		return;
	}

	if ( ProxyToolbox.checkAndProxy( is, study, true ) ) {
		logger.syslog( Syslog.LOG_DEBUG, "checkAndProxy is true" );
		return;
	}

	logger.syslog( Syslog.LOG_DEBUG, "Create Response" );

	try {
		String cacheDirName = RepositoryHandler.createLocation( IMEnvBase.getEnv( "REPOSITORY_CACHE" ), study, false );
		if ( cacheDirName == null ) {
			response.sendError( 500, "Study was not found in cache repository" );
			return;
		}
		File cacheFile = new File( cacheDirName + "/" + file );
		if ( ! cacheFile.exists() ) {
			String studyDirName = RepositoryHandler.getLocation( IMEnvBase.getEnv( "REPOSITORY_DATA_DICOM" ), study );
			if ( studyDirName == null ) {
				response.sendError( 500, "Study was not found in DICOM repository" );
				return;
			}
			if ( ! new File( studyDirName + "/" + file ).exists() ) {
				response.sendError( 500, "Document file was not found in study directory " +  studyDirName + "/" + file);
				return;
			}
			
			Vector<String> cmd = new Vector<String>();
			cmd.add( IMEnvBase.getEnv( "SR_HOME" ) + "/bin/extractPdf" );
			cmd.add( studyDirName + "/" + file );
			cmd.add( cacheDirName + "/" + file );
			
			if ( Helper.runCommandEx( cmd.toArray( new String[ 0 ] ), null ).getExitCode() != 0 ) {
				response.sendError( 500, "Executing " + cmd.toString() + " failed" );
				return;
			}
		}
		
		if ( ! cacheFile.exists() ) {
			response.sendError( 500, "Extracting Document from DICOM object failed" );
			return;
		}
		
		long length = cacheFile.length();
		response.setContentType( "application/pdf" );
		response.setHeader( "Content-length", Long.toString( length ) );
		response.addHeader( "Content-Disposition", "attachment; filename=\"" + file + ".pdf\"");

		response.setStatus( HttpServletResponse.SC_OK );
	
		FileInputStream inStream = new FileInputStream( cacheFile );
		ServletOutputStream outStream = response.getOutputStream(); 
		long from = 0;
		long to = length;
		byte[] buffer = new byte[SIZE];
		int nBytes;
	
		while ( from < to ) {
			int r = SIZE;
			if ( to - from < SIZE ) {
				r = ( int ) ( to - from );
			}
			nBytes = inStream.read( buffer, 0, r );
	
			outStream.write( buffer, 0, nBytes );
			from += nBytes;
		}
	
		inStream.close();

	}
	catch(Throwable t1) {
		// not found or other I/O error

		response.reset();
		response.setHeader("Content-type","text/html");
		String msg = "<HTML>\n<HEAD><TITLE>Not Found</TITLE></HEAD>\n<BODY><H2>File " +
				file + " not found...</H2></BODY>\n</HTML>\n";
		response.setHeader("Content-length", Integer.toString(msg.length()));
		out.print(msg);
	}

	if (true) {
		// For avoiding extra newline(s)
		return;
	}
%>
--%>