<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--<%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,java.io.*,imagemed.http.tabs.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

	private BufferedReader logFile;
	private BufferedReader infoFile;
	private long cnt = 0;
	private long percent = 0;
	
	/**
	* this method protects some of the characters in a string, to be displayable through the ws() javascript
	* @param val
	* @return
	*/
	private String protect(String val) {
		String result = Helper.replace(val, "\\", "\\\\");
		result = Helper.replace(result, "\"", "\\\"");
		result = Helper.replace(result, "\'", "`");
		return result;
	}

	private String readLine() {
		try {
			return logFile.readLine();
		}
		catch ( Exception e ) {
		}
		return null;
	}

	private double emptyCnt;

	private String html(long studyCount, IMSession is) { 
		String html = StyleToolbox.getStylePart( is, "tableStyles" ) + LocalizedMessage.getSimpleMessage( "CD_PROGRESS_GATHER_CONVERT" );
		long limit = studyCount;
		String separator = "--------";
		String nextLine = readLine();
		while(nextLine != null && cnt < limit) {
			if (nextLine.startsWith(separator)) {
				cnt++;
			}
			nextLine = readLine();
		}
		html += CDBurnToolbox.writeProgress(cnt, limit, is);
		if (cnt < limit) {
			return html;
		}
		html += LocalizedMessage.getSimpleMessage( "CD_PROGRESS_CREATE" );
		String lastStr = "";
		while (nextLine != null) {
			lastStr = nextLine.trim();
			nextLine = readLine();
			int p = lastStr.indexOf(".");
			if (p >0) {
				try {
					percent = Long.parseLong(lastStr.substring(0, p));
				}
				catch (NumberFormatException nfe) {
					 if (percent > 0) {
						percent = 100;
					}
				}
			}
			else if (percent > 0) {
				percent = 100;
			}
		}

	    emptyCnt = emptyCnt*9/10;
		html += CDBurnToolbox.writeProgress((percent>0)?(20+percent*8/10):(20-emptyCnt), 100, is);
		return html;
	}

%><%

	IMSession is = new IMSession(request, response, out); 

	if (!is.regOK()) {
		return;
	}
	String jsPre = "<script language=JavaScript >parent.push('";

	String jsPost = "')</script> ";

	String backLink="cBack="+Helper.URLEncodeUTF8(request.getParameter("cBack"));
	String id = request.getParameter("id");
	String ext = request.getParameter( "ext" );

	long studyCount = -1;
	try {
		studyCount =Long.parseLong(request.getParameter("studyCount"));
	}
	catch ( Exception e ) {
	}
	String dir = IMEnvBase.getEnv("TMP")+"/cd"+id;
	File doneFile = new File(dir + "/cdimage.done");
	File infoF = new File(IMEnvBase.getEnv("TMP")+"/info"+id+".html");
	try {
		logFile = new BufferedReader(new FileReader(new File(IMEnvBase.getEnv("TMP")+"/cdlog"+id+".log")));
		infoFile = new BufferedReader(new FileReader(infoF));
	}
	catch ( FileNotFoundException fnfe ) {
	}
	cnt = 0;
	percent = 0;
    emptyCnt = 20;

%><HTML>
<HEAD>
	<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
	<META HTTP-EQUIV="Pragma" CONTENT="no-cache">

	<script language="JavaScript">
		var checkUnload = true;
		var isDownloaded = false;
		
		function push0(content) {
			parent.window.frames['infoFrame'].document.writeln(content);
			parent.window.frames['infoFrame'].document.close();
		}
	
		function unLoad() {
			if (!checkUnload) {
				return true;
			}
			if (!isDownloaded) {
				alert( "<%= LocalizedMessage.getSimpleMessage( "CD_PROGRESS_ABORTED" )%>" );
			}
			open("deldir.jsp?<%="id="+id%>");
			return true ;
		}
		
		function exit() {
<% if ( "iso".equals( ext ) ) { %>
			var text = "<%= LocalizedMessage.getSimpleMessage( "CD_PROGRESS_HAVE_NOT_DOWNLOAD_BURNED_ISO" ) %>";
<% } else { %>
			var text = "<%= LocalizedMessage.getSimpleMessage( "CD_PROGRESS_HAVE_NOT_DOWNLOAD_DICOM" ) %>";
<% } %>
			if (isDownloaded || confirm(text)) {
				checkUnload=false;
				parent.jump('deldir.jsp?<%="id="+id+"&"+backLink%>');
			}
		}
	</script>
<%
	imagemed.http.tabs.TabBean.writeStyleOnly(is);
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(is);
%>
</HEAD>
<BODY onUnload="return unLoad();">
<%
	if (infoFile != null) {
		try {
			String nextLine = "<html><head>"+StyleToolbox.getStylePart( is, "tableStyles" )+"</head><body><center><br><h2>" + LocalizedMessage.getSimpleMessage( "CD_PROGRESS_LAUNCH_CREATION_CONFORMANT_ISO") + ":</h2><BR>";
			out.println("<script language=\"JavaScript\">");
			while (nextLine != null) {
				out.println("	parent.window.frames['infoFrame'].document.writeln(\""+protect(nextLine)+"\");");
				nextLine = infoFile.readLine();
			}
			out.println("	parent.window.frames['infoFrame'].document.close();");
			out.println("</script>");
		}
		catch ( IOException ioe ) {
		}
		infoFile.close();
	}
	File dirFile = doneFile.getParentFile();
	while (!doneFile.exists() && dirFile.exists()) {
		out.print(jsPre+html(studyCount, is)+jsPost);
		out.flush();
		// Sleep 
		try {
			Thread.sleep(500);
		} 
		catch (InterruptedException e) {
			break;
		}
	}
	percent=100;
	String result = Helper.readTextFile( doneFile.getAbsolutePath() );
	boolean isOK = result != null && "DONE".equals( result.trim() );
	
	out.print( jsPre );
	if ( !isOK ) {
		out.print( StyleToolbox.getStylePart( is, "tableStyles" ) + "<DIV class=\"fontError\">" + LocalizedMessage.getSimpleMessage( "CD_PROGRESS_CREATE_DICOM_FAIL" ) );
		if ( result != null && result.startsWith( "ERROR: " ) ) {
			out.print( "<BR>" + result.substring( 7 ).trim() );
		}
		out.print( "</DIV>" );
	}
	else {
		out.print( html( studyCount, is ) );
	}
	out.println( jsPost );
	out.flush();

	out.println( "<CENTER>" );
	
	if ( isOK ) {
		out.println( "<SCRIPT language=\"JavaScript\">parent.showApplet()</SCRIPT>" );
		if (IMAdminToolbox.bAdminRight(is) && "iso".equals(ext) )  {//Has ADMIN RIGHT?
%>
  <A href="javascript:parent.jump('isoburner.jsp?<%="id="+id+"&"+backLink%>');" onClick = "isDownloaded=true;checkUnload=false;">
  <%= JSHelper.getJsLocalizedButton( "BUTTON_BURN_ON_SERVER", "BUTTON_NULL", false ) %></A> 
<%
		}
	}
	else {
		out.println( "<SCRIPT language=\"JavaScript\">isDownloaded = true;</SCRIPT>" );
	}
%>
	<A href="viewlog.jsp?id=<%=id%>" target=new><%= JSHelper.getJsLocalizedButton( "BUTTON_VIEW_LOG", "BUTTON_NULL" , false )%></A> 
	<A href="viewlog.jsp?id=<%=id%>&cType=text" target=new><%= JSHelper.getJsLocalizedButton( "BUTTON_VIEW", "BUTTON_NULL", false )%></A> 
	<A href="javascript:exit()"><%= JSHelper.getJsLocalizedButton("BUTTON_BACK_TO_LIST", "BUTTON_NULL", false ) %></A>
	</center>
</body>
</html>--%>