<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--<%@page import="imagemed.util.UserPreferences.SelectUserProfile"%>
<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="java.util.*, java.io.*, java.text.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.util.*"

%><%!
static String thisPage = "/pref/settings.jsp";
%><%
	IMSession is = new IMSession( request, response, out ); 
	if ( !is.regOK() ) {
		return;
	}

%><HTML>
<HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "PREFERENCES_SETTINGS_HTMLPAGE_TITLE" ) %></TITLE>
<%
	TabToolbox.writeIMpopup(out);
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(is);
	UserPreferences.guiPrintJSInclude( is );
	
%>
</HEAD>
<BODY>
<%
	TabToolbox.makeTabs( is, is.tabbean, "pref/settings.jsp", "White");

	UserPreferences prefs = new UserPreferences( is.regID );
	prefs.load();
	
	UserPreferences.SaveNotification saveNotification = null;

	if ( "Save".equals( request.getParameter( "cOp" ) ) ) {
		if ( prefs.processForm( is ) ) {
			prefs.save();
			saveNotification = new UserPreferences.SaveNotification( LocalizedMessage.getSimpleMessage( "PREFERENCES_SETTINGS_SAVE_NOTIFICATION" ) );
			if( prefs.isRefreshNeeded() ) {
				//redirect to this page to change language at once
				response.sendRedirect( thisPage );
				return;
			}
		}
	}
	
	String lang = prefs.getPreference( "language" );
	String timeZone = prefs.getTimeZoneFromDb();
	String theme = prefs.getPreference( "theme" );
	String icon_scheme = prefs.getPreference( "icon_scheme" );
	String defPage = prefs.getPreference( "default_page" );
	String qvSize = prefs.getPreference( "qv_thumbnail_size" );
	
	String viewerPref = prefs.getPreference( "burn_add_viewer" );
	String srPref = prefs.getPreference( "burn_omit_sr" );
	String mediaTypePref = prefs.getPreference( "burn_media_type" );
	String compressionPref = prefs.getPreference( "burn_compression" );
	String profileUserPref = prefs.getPreference( "burn_profile_user" );

	String doubleclickSpeed = prefs.getPreference( "webviewer_doubleclick_speed" );
	String dynamicHelp = prefs.getPreference( "webviewer_dynamic_help" );
	String reportArea = prefs.getPreference( "webviewer_reportarea_size" );
	String showScanned = prefs.getPreference( "webviewer_show_scanned" );
	
	String warnMacro = "<SPAN id=up_media_warning_compression style=\"font-style: italic\"></SPAN>";
%>
<table width="100%" border=1 cellspacing=0 cellpadding=2 class=BgShadow>
<FORM name="settingsForm" method="POST">
<%
	String title = LocalizedMessage.getCompoundMessage( "PREFERENCES_SETTINGS_TITLE", new Format[] { null }, new Object[] { is.regID }, false );
	UserPreferences.guiPrintPageHeaderRow( is, title, "settingsForm", saveNotification );

	UserPreferences.guiPrintSectionHeaderRow( is, LocalizedMessage.getSimpleMessage( "PREFERENCES_SETTINGS_TITLE_GENERAL" ) );

	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage("PREFERENCES_SETTINGS_LANGUAGE"), UserPreferences.SELECT_LANGUAGE, lang );
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage("PREFERENCES_SETTINGS_TIMEZONE"), UserPreferences.getSelectTimeZone(), timeZone );
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage("PREFERENCES_SETTINGS_THEME"), UserPreferences.SELECT_THEME, theme );
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage("PREFERENCES_SETTINGS_ICON_SCHEME"), UserPreferences.SELECT_ICON_SCHEME, icon_scheme );
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage("PREFERENCES_SETTINGS_DEFAULT_PAGE"), UserPreferences.SELECT_DEFAULT_PAGE, defPage );
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage("PREFERENCES_SETTINGS_THUMBNAIL_SIZE") , UserPreferences.SELECT_QV_THUMBNAIL, qvSize );


	
	UserPreferences.RawElem warningSpan = new UserPreferences.RawElem(
	"<SPAN ID=up_media_warning style=\"color: Gold; visibility:hidden\"s>" +
	LocalizedMessage.getCompoundMessage( "BURN_MEDIA_OPTION_MEDIA_PROFILE_WARNING", new Format[] { null }, new Object[] { warnMacro }, false ) + "</SPAN>" );

	UserPreferences.guiPrintSectionHeaderRow( is, LocalizedMessage.getSimpleMessage( "BURN_MEDIA_OPTIONS" ) );
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "BURN_MEDIA_OPTION_MEDIA_TYPE" ),
	UserPreferences.SELECT_MEDIA_TYPE, mediaTypePref );
	
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "BURN_MEDIA_OPTION_MEDIA_PROFILE" ),
	new UserPreferences.Elem[] { UserPreferences.SELECT_MEDIA_COMPRESSION, warningSpan }, compressionPref );
	
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "BURN_MEDIA_OPTION_ADD_VIEWER" ),
	new UserPreferences.Checkbox( UserPreferences.getFormName( "burn_add_viewer" ), "true" ), viewerPref );
	
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "BURN_MEDIA_OPTION_OMIT_SR" ),
	new UserPreferences.Checkbox( UserPreferences.getFormName( "burn_omit_sr" ), "true" ), srPref );
	
	SelectUserProfile sup = UserPreferences.getSelectForUserprofile( is );
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "BURN_MEDIA_PROFILE_USER" ),
	sup, sup.getCurrentValue( is, profileUserPref ) );

%>
	<SCRIPT language="JavaScript">resetMediaProfiles( '<%= mediaTypePref %>','<%= compressionPref %>' );</script>
<%

	UserPreferences.guiPrintSectionHeaderRow( is, LocalizedMessage.getSimpleMessage( "WEBVIEWER_OPTIONS" ) );

	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "WEBVIEWER_OPTION_DOUBLECLICK_SPEED" ),
		new UserPreferences.InputElem( UserPreferences.getFormName( "webviewer_doubleclick_speed" ), "text", null, 4, 4 ), doubleclickSpeed );

	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "WEBVIEWER_OPTION_DYNAMIC_HELP" ),
			new UserPreferences.Checkbox( UserPreferences.getFormName( "webviewer_dynamic_help" ), "true" ), dynamicHelp );

	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "WEBVIEWER_OPTION_REPORTAREA_SIZE" ),
			new UserPreferences.InputElem( UserPreferences.getFormName( "webviewer_reportarea_size" ), "text", null, 3, 3 ), reportArea );

	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "WEBVIEWER_OPTION_SHOW_SCANNED" ),
			new UserPreferences.Checkbox( UserPreferences.getFormName( "webviewer_show_scanned" ), "true" ), showScanned );

	
	// ------------------- Report Panel Options -----------------------------
	UserPreferences.guiPrintSectionHeaderRow( is, LocalizedMessage.getSimpleMessage( "REPORT_PANEL_OPTIONS" ) );

	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "REPORT_PANEL_MARKER_CLEANUP" ),
			new UserPreferences.Checkbox( UserPreferences.getFormName( ReportFunctions.DOCLEARMARKERS ), "true" ), prefs.getPreference( ReportFunctions.DOCLEARMARKERS ) );

	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "REPORT_PANEL_MARKER_BEGIN" ),
		new UserPreferences.InputElem( UserPreferences.getFormName( ReportFunctions.MARKERBEGIN ), "text", null, 4, 4 ), prefs.getPreference( ReportFunctions.MARKERBEGIN ) );

	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "REPORT_PANEL_MARKER_END" ),
			new UserPreferences.InputElem( UserPreferences.getFormName( ReportFunctions.MARKEREND ), "text", null, 4, 4 ), prefs.getPreference( ReportFunctions.MARKEREND ) );

	UserPreferences.guiPrintPageFooterRow( is, "settingsForm" );
%>
	<INPUT TYPE="HIDDEN" NAME="cOp" VALUE="Save"></INPUT>
</FORM>
</TABLE>

<%-- %>pre><%= prefs.getDebug() %></pre-- %>
</BODY>
</HTML>
--%>